﻿Imports System.Math

Public Class NumberLine

    '//**********************************************************
    '//　数直線を作成する
    '//　区間の速度はｃｏｓ関数で変化する
    '//　数直線は０から始まる
    '//　引数
    '//　　coo：計算結果の数直線
    '//　　　coo[][0]：積算位置
    '//　　　coo[][1]：差分
    '//　　number_line：数直線用構造体
    '//　戻り値
    '//　　データ数
    '//**********************************************************
    Shared Sub type1b(ByRef coo(,) As Double, ByVal length As Double, ByVal point_num As Integer)
        Dim i, num As Integer
        Dim dist, a, t, dt_rad, v As Double

        dist = length

        num = point_num

        dt_rad = 2.0 * PI / point_num
        t = dt_rad
        a = dist / point_num

        coo(0, 0) = 0.0
        coo(0, 1) = 0.0

        For i = 1 To point_num - 1
            v = -(a * Cos(t)) + a
            coo(i, 0) = coo(i - 1, 0) + v '//積算位置
            coo(i, 1) = v '//差分
            t = t + dt_rad
        Next

    End Sub
End Class
