﻿Imports System.Math

Public Class RoboIo
    '----------------------------------------------------------------------------------------------------
    '２バイトの整数をシリアルポートから出力する（引数は文字列）********************
    Public Shared Sub write_sio_int(ByVal input_str As String)
        '変数定義
        Dim buff(64) As Byte
        Dim output_val As Integer
        'テキストボックスの文字列を整数に変換
        output_val = Val(input_str)
        '変換した整数の出力値を上位バイトと下位バイトに分割してバッファにセット
        buff(0) = Int(output_val / 256)
        buff(1) = output_val - Int(output_val / 256) * 256
        'シリアルポートから出力
        frmMain.SerialPort1.Write(buff, 0, 2)
    End Sub
    '----------------------------------------------------------------------------------------------------
    '２バイトの整数をシリアルポートから出力する（引数はInt）********************
    Public Shared Sub write_sio_int(ByVal output_val As Integer)
        '変数定義
        Dim buff(64) As Byte

        '整数の出力値を上位バイトと下位バイトに分割してバッファにセット
        buff(0) = Int(output_val / 256)
        buff(1) = output_val - Int(output_val / 256) * 256
        'シリアルポートから出力
        frmMain.SerialPort1.Write(buff, 0, 2)

    End Sub
    '----------------------------------------------------------------------------------------------------
    '２バイトの整数をシリアルポートから読み取る********************
    Public Shared Function read_sio_int() As Integer

        Dim j As Integer
        Dim buff(64) As Byte

        frmMain.SerialPort1.Read(buff, 0, 1)
        j = buff(0) * 256
        frmMain.SerialPort1.Read(buff, 0, 1)
        j = j + buff(0)

        Return (j)

    End Function
    '----------------------------------------------------------------------------------------------------
    '２バイトの整数をシリアルポートから読み取る（テキストで返す）********************
    Public Shared Function read_sio_int_a() As Char

        Dim j As Integer
        Dim work_str As Char

        j = read_sio_int()
        work_str = Format(j)

        Return (work_str)

    End Function
    '----------------------------------------------------------------------------------------------------
    Shared Function angle2servo(ByVal side_id As Integer, ByVal joint_id As Integer, ByVal joint_angle As Double) As Double

        Dim i, j, servo_data As Integer
        Dim a, b, q_refp(3) As Double

        '参照点の角度をラジアンに変換
        j = 0
        For i = 0 To 2
            j = i * 2
            q_refp(i) = frmUtils.servo_st_en(side_id, joint_id, j) / 180.0 * PI
        Next i

        '補間直線の傾きを求める
        joint_angle = joint_angle / 180.0 * PI
        If joint_angle > q_refp(1) Then
            a = (frmUtils.servo_st_en(side_id, joint_id, 5) - frmUtils.servo_st_en(side_id, joint_id, 3)) _
                / (q_refp(2) - q_refp(1))
        Else
            a = (frmUtils.servo_st_en(side_id, joint_id, 3) - frmUtils.servo_st_en(side_id, joint_id, 1)) _
                / (q_refp(1) - q_refp(0))
        End If

        '補間直線のＹ切片を求める
        b = frmUtils.servo_st_en(side_id, joint_id, 3) - a * q_refp(1)

        servo_data = Int((a * joint_angle + b))

        Return (servo_data)
    End Function
    '----------------------------------------------------------------------------------------------------
    'joint_id を０～２１で与えるバージョン
    Shared Function angle2servo(ByVal joint_id As Integer, ByVal joint_angle As Double) As Double

        Dim id, side_id, servo_data As Integer

        '目標角度のrawデータを求める
        If joint_id < 11 Then
            side_id = 1
            id = joint_id
        Else
            side_id = 0
            id = joint_id - 11
        End If

        servo_data = angle2servo(side_id, id, joint_angle)

        Return (servo_data)

    End Function

End Class
