﻿Public Class frmPgmMode
    Public Shared slowdn_on As Boolean
    Public Shared feed_rate As Double
    Public Shared last_coo(3) As Double
    Dim fname As String

    '全部のサーボを動かすモード
    Public Shared Sub move_servo(ByRef joint_ang() As Double)
        Dim i, id, side_id, servo_data As Integer
        Dim buff(4) As Byte
        Dim servo_data_str As String

        '角度指定で動かす場合は関節パラメータファイルの情報をベースに入力チェック
        side_id = 0
        For i = 0 To 7
            id = i
            If joint_ang(i) < frmUtils.servo_min_max(side_id, id, 0) Or joint_ang(i) > frmUtils.servo_min_max(side_id, id, 1) Then
                MsgBox("エラー：入力値が関節稼働範囲を超えています", MsgBoxStyle.Exclamation)
                Exit Sub
            End If
        Next

        '０番～７番サーボに信号出力値を送信する
        'マイコンにＲＣサーボ制御信号　状態変更コマンドを送信
        frmUtils.write_sio_command("B")
        '補間なし
        For i = 0 To 7
            servo_data = JointCalc.angle2servo(i, joint_ang(i))
            servo_data_str = Format(servo_data)
            frmUtils.write_sio_int(servo_data_str)
        Next
    End Sub
    '----------------------------------------------------------------------------------------------------
    Private Sub frmPgmMode_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim buff(4) As Byte

        slowdn_on = False
        feed_rate = 30 '(point)

        If frmMain.SerialPort1.IsOpen Then

            '脱力モード解除
            frmUtils.write_sio_command("K")
            buff(0) = 1
            frmMain.SerialPort1.Write(buff, 0, 1)

            frmUtils.init_value()
            move_servo(frmUtils.servo_data_present_deg)

        End If

        last_coo(0) = 22.0
        last_coo(1) = 0.0
        last_coo(2) = 10.0

    End Sub
    '----------------------------------------------------------------------------------------------------
    'frmMainに帰る********************
    Private Sub btnReturn_Click(sender As System.Object, e As System.EventArgs) Handles btnReturn.Click

        frmUtils.Visible = True
        frmPlmEdit.Visible = True

        Me.Visible = False
    End Sub

    '実行ボタンの処理・・・テキストボックスのＮＣプログラムによってロボットを動かす。
    Private Sub btnRun_Click(sender As System.Object, e As System.EventArgs) Handles btnRun.Click
        Dim i, total_linenum, dlay_time As Integer
        Dim line, work_str_arr(), pgm_str() As String
        Dim invalid_line As Boolean
        Dim joint_angle(3) As Double
        Dim servo_data(3) As Integer
        Dim buff(4) As Byte

        'ボタンの色を動作中色に変更
        Me.btnRun.BackColor = Values.active_button_color

        'テキストの行数を取得
        total_linenum = txtPgm.Lines.Length
        pgm_str = txtPgm.Lines

        'プログラムの解釈開始
        i = 0
        Do While (i < total_linenum)
            '１行取り込み
            line = pgm_str(i).ToUpper
            invalid_line = True

            '空白行でない場合処理
            If line.Length > 0 Then
                'コメント行でない場合処理
                If line(0) <> "$" Then
                    txtPgmCurrent.Text = Str(i) + " : " + line
                    work_str_arr = line.Split("/")

                    txtPgmCurrent.Refresh()
                    txtPgm.Refresh()
                    System.Threading.Thread.Sleep(100)

                    If work_str_arr.Length > 0 Then
                        'DLAYの処理（引数の数字×msec時間、その行で実行中断）
                        If work_str_arr(0) = "DLAY" Then
                            dlay_time = Val(work_str_arr(1))
                            System.Threading.Thread.Sleep(dlay_time)
                            invalid_line = False
                        End If

                        'FEDRATの処理（フィードレート　単位はmm/min）
                        If work_str_arr(0) = "FEDRAT" Then
                            feed_rate = Val(work_str_arr(1))
                            invalid_line = False
                        End If

                        'GOTOの処理
                        If work_str_arr(0) = "GOHOME" Then

                            last_coo(0) = 22.0
                            last_coo(1) = 0.0
                            last_coo(2) = 10.0

                            JointCalc.coo2servo3ax(last_coo, servo_data, joint_angle)
                            frmPgmMode.move_servo(frmUtils.servo_data_present_deg)

                            For j = 0 To 2
                                frmUtils.servo_data_present_deg(j) = joint_angle(j)
                                frmUtils.servo_data_present(j) = servo_data(j)
                            Next

                            invalid_line = False
                        End If

                        'GOTOの処理
                        If work_str_arr(0) = "GOTO" Then
                            APT.mw_GOTO(work_str_arr(1))
                            invalid_line = False
                        End If

                        'SLOWDNの処理
                        If work_str_arr(0) = "SLOWDN" Then

                            invalid_line = False
                        End If

                        'SPINDLの処理
                        If work_str_arr(0) = "SPINDL" Then
                            If work_str_arr(1) = "ON" Then
                                'LED ON
                                frmUtils.write_sio_command("A")
                                buff(0) = 1
                                frmMain.SerialPort1.Write(buff, 0, 1)
                            Else
                                'LED OFF
                                frmUtils.write_sio_command("A")
                                buff(0) = 0
                                frmMain.SerialPort1.Write(buff, 0, 1)
                            End If

                            invalid_line = False
                        End If

                    Else
                        invalid_line = False
                    End If

                    If invalid_line = True Then
                        MsgBox("処理できない行です。" + vbCrLf + Str(i) + " : " + line, MsgBoxStyle.Information)
                    End If
                End If
            End If

            i = i + 1
        Loop

        'MsgBox("実行終了。行数＝" & Str(i))
        'ボタンの色を停止中色に変更
        Me.btnRun.BackColor = Values.org_back_color

    End Sub

    Private Sub btnLoad_Click(sender As System.Object, e As System.EventArgs) Handles btnLoad.Click

        Dim work_arr(), line As String

        OpenFileDialog1.FileName = ""
        OpenFileDialog1.ShowDialog()
        fname = OpenFileDialog1.FileName

        If fname <> "" Then
            FileOpen(1, fname, OpenMode.Input)
            txtPgm.Clear()

            Do While (EOF(1) = False)
                line = LineInput(1)
                txtPgm.AppendText(line)
                txtPgm.AppendText(vbCrLf)
            Loop

            FileClose(1)
            work_arr = fname.Split("\")
            lblFname.Text = work_arr(work_arr.Length - 1)
        End If
    End Sub

    Private Sub btnSave_Click(sender As System.Object, e As System.EventArgs) Handles btnSave.Click

        Dim i, line_num As Integer
        Dim work_arr() As String

        SaveFileDialog1.FileName = lblFname.Text
        SaveFileDialog1.ShowDialog()
        fname = SaveFileDialog1.FileName

        If fname <> "" Then
            line_num = txtPgm.Lines.Length

            FileOpen(1, fname, OpenMode.Output)
            For i = 0 To line_num - 1
                PrintLine(1, txtPgm.Lines(i))
            Next

            FileClose(1)

            work_arr = fname.Split("\")
            lblFname.Text = work_arr(work_arr.Length - 1)
        End If

    End Sub
End Class