﻿Imports System.Math

Public Class frmUtils

    Public Shared ar_textbox(7) As TextBox
    Public Shared ar_radiobutton(7) As RadioButton
    Public Shared joint_data_org(7) As String

    Public Shared joint_data_raw(7) As String
    Public Shared joint_data_deg(7) As String

    Public Shared diff_S As Integer = 25
    Public Shared diff_L As Integer = diff_S * 10

    Public Shared diff_Sdeg As Integer = 1
    Public Shared diff_Ldeg As Integer = diff_Sdeg * 5

    Public Shared passive_mode As Boolean = False
    Public Shared first_move As Boolean = True

    Public Shared bone_area_name(2) As String '  各関節間の距離　フィールド名
    Public Shared bone_field_name(2, 15) As String '  各関節間の距離　フィールド名
    Public Shared bone_length(2, 15) As Double '  各関節間の距離

    Public Shared servo_st_en_area_name(2, 2) As String '  サーボ角度－出力データ対応関係　フィールド名
    Public Shared servo_st_en_field_name(2, 11) As String '  サーボ角度－出力データ対応関係　フィールド名
    Public Shared servo_st_en(2, 11, 6) As Double '  サーボ角度－出力データ対応関係の読み込み
    '  角度１：データ１：角度２：データ２：角度３：データ３

    Public Shared servo_min_max_area_name(2, 2) As String '  サーボ稼働範囲　フィールド名
    Public Shared servo_min_max_field_name(2, 11) As String '  サーボ稼働範囲　フィールド名
    Public Shared servo_min_max(2, 11, 2) As Double '  サーボ稼働範囲

    Public Shared servo_data_present(7), servo_diff(7) As Integer
    Public Shared servo_data_present_deg(7) As Double

    '----------------------------------------------------------------------------------------------------
    '変数初期化
    Public Sub init_value()
        Dim i As Integer

        joint_home_read()
        '骨格長と関節可動範囲　読み込み
        JointPlm.fread_pal("edu_arm1.pal")
        '変換テーブル（rawデータ－＞角度）　読み込み
        JointPlm.fread_convtab("edu_arm1_convtab.pal")

        'ＲＣサーボの初期値をセーブ
        For i = 0 To 7
            joint_data_org(i) = ar_textbox(i).Text
            joint_data_raw(i) = ar_textbox(i).Text
            joint_data_deg(i) = "0.0"

            servo_data_present(i) = Val(ar_textbox(i).Text)
            servo_diff(i) = 0

            servo_data_present_deg(i) = 0.0
        Next
        joint_data_deg(1) = "90.0"
        joint_data_deg(2) = "-85.0"
        servo_data_present_deg(1) = 90.0
        servo_data_present_deg(2) = -85.0

    End Sub
    '----------------------------------------------------------------------------------------------------
    'ロボット制御コマンドキャラクター送信********************
    Public Sub write_sio_command(ByVal command As Char)
        '変数定義
        Dim command_char(64), buff(64) As Byte
        'マイコンにコマンドを送信
        command_char(0) = Asc(command)
        frmMain.SerialPort1.Write(command_char, 0, 1)
        '受信確認待ちとエラー処理
        Try
            frmMain.SerialPort1.Read(buff, 0, 1)
        Catch ex As TimeoutException
            MsgBox("通信エラーです。ロボットが規定時間以内に応答しません")
            End
        End Try
        If command_char(0) <> buff(0) Then
            MsgBox("通信エラーです。ロボットがコマンドに正しく応答しません")
            End
        End If
    End Sub

    '----------------------------------------------------------------------------------------------------
    '２バイトの整数をシリアルポートから出力する（引数は文字列）********************
    Public Sub write_sio_int(ByVal input_str As String)
        '変数定義
        Dim buff(64) As Byte
        Dim output_val As Integer
        'テキストボックスの文字列を整数に変換
        output_val = Val(input_str)
        If output_val >= 0 Then
            '変換した整数の出力値を上位バイトと下位バイトに分割してバッファにセット
            buff(0) = Int(output_val / 256)
            buff(1) = output_val - Int(output_val / 256) * 256
            'シリアルポートから出力
            frmMain.SerialPort1.Write(buff, 0, 2)
        Else
            MsgBox("write_sio_int:出力値が０未満になっています。", MsgBoxStyle.Critical)
        End If

    End Sub

    '----------------------------------------------------------------------------------------------------
    '２バイトの整数をシリアルポートから出力する（引数はInt）********************
    Public Sub write_sio_int(ByVal output_val As Integer)
        '変数定義
        Dim buff(64) As Byte

        '整数の出力値を上位バイトと下位バイトに分割してバッファにセット
        buff(0) = Int(output_val / 256)
        buff(1) = output_val - Int(output_val / 256) * 256
        'シリアルポートから出力
        frmMain.SerialPort1.Write(buff, 0, 2)

    End Sub

    '----------------------------------------------------------------------------------------------------
    Private Sub frmUtils_Load(sender As Object, e As System.EventArgs) Handles Me.Load

        Dim i, j As Integer

        '変数の初期化
        'テキストボックスの配列初期化
        ar_textbox(0) = TextBox1
        ar_textbox(1) = TextBox2
        ar_textbox(2) = TextBox3
        ar_textbox(3) = TextBox4
        ar_textbox(4) = TextBox5
        ar_textbox(5) = TextBox6
        ar_textbox(6) = TextBox7
        ar_textbox(7) = TextBox8

        'ラジオボタンの配列初期化
        ar_radiobutton(0) = RadioButton1
        ar_radiobutton(1) = RadioButton2
        ar_radiobutton(2) = RadioButton3
        ar_radiobutton(3) = RadioButton4
        ar_radiobutton(4) = RadioButton5
        ar_radiobutton(5) = RadioButton6
        ar_radiobutton(6) = RadioButton7
        ar_radiobutton(7) = RadioButton8

        init_value()

        '関節パラメータファイルから読んだ内容をコンボボックスの選択項目としてセット
        i = 0
        For j = 0 To 7
            frmPlmEdit.cmbJointSelect.Items.Add(servo_st_en_field_name(i, j))
        Next

        radioRaw.Checked = True
        frmPlmEdit.cmbJointSelect.SelectedIndex = 0

        passive_mode = True
        'ボタンの色を動作中色に変更
        Me.Button3.BackColor = Values.active_button_color

        passive_mode = True
        btnSnedData.Enabled = False

    End Sub

    '----------------------------------------------------------------------------------------------------
    'frmMainに帰る********************
    Private Sub btnReturn_Click(sender As System.Object, e As System.EventArgs) Handles btnReturn.Click
        frmMain.Visible = True
        Me.Visible = False
        frmPlmEdit.Visible = False
    End Sub

    '----------------------------------------------------------------------------------------------------
    Private Sub btnUp_S_Click(sender As System.Object, e As System.EventArgs) Handles btnUp_S.Click
        Dim i As Integer

        'サーボの出力値を増やす（小）
        For i = 0 To 7
            If ar_radiobutton(i).Checked = True Then
                If radioDeg.Checked = False Then
                    ar_textbox(i).Text = Format(Val(ar_textbox(i).Text) + diff_S)
                Else
                    ar_textbox(i).Text = Format(Val(ar_textbox(i).Text) + diff_Sdeg)
                End If
            End If
        Next

    End Sub

    '----------------------------------------------------------------------------------------------------
    Private Sub btnUp_L_Click(sender As System.Object, e As System.EventArgs) Handles btnUp_L.Click
        Dim i As Integer

        'サーボの出力値を増やす（大）
        For i = 0 To 7
            If ar_radiobutton(i).Checked = True Then
                If radioDeg.Checked = False Then
                    ar_textbox(i).Text = Format(Val(ar_textbox(i).Text) + diff_L)
                Else
                    ar_textbox(i).Text = Format(Val(ar_textbox(i).Text) + diff_Ldeg)
                End If
            End If
        Next

    End Sub

    '----------------------------------------------------------------------------------------------------
    Private Sub btnDown_S_Click(sender As System.Object, e As System.EventArgs) Handles btnDown_S.Click
        Dim i, j As Integer
        'サーボの出力値を減らす（小）
        For i = 0 To 7
            If ar_radiobutton(i).Checked = True Then
                If radioDeg.Checked = False Then
                    j = Val(ar_textbox(i).Text) - diff_S
                    If j >= 0 Then ar_textbox(i).Text = Format(j)
                Else
                    ar_textbox(i).Text = Format(Val(ar_textbox(i).Text) - diff_Sdeg)
                End If
            End If
        Next

    End Sub

    '----------------------------------------------------------------------------------------------------
    Private Sub btnDown_L_Click(sender As System.Object, e As System.EventArgs) Handles btnDown_L.Click
        Dim i, j As Integer
        'サーボの出力値を減らす（大）
        For i = 0 To 7
            If ar_radiobutton(i).Checked = True Then
                If radioDeg.Checked = False Then
                    j = Val(ar_textbox(i).Text) - diff_L
                    If j >= 0 Then ar_textbox(i).Text = Format(j)
                Else
                    ar_textbox(i).Text = Format(Val(ar_textbox(i).Text) - diff_Ldeg)
                End If
            End If
        Next

    End Sub

    'マイコンにＲＣサーボ8個の信号出力値を送信する********************
    Private Sub btnSnedData_Click(sender As System.Object, e As System.EventArgs) Handles btnSnedData.Click
        Dim i, total_diff As Integer
        Dim buff(4) As Byte

        If radioRaw.Checked = True Then
            For i = 0 To 7
                total_diff = Val(ar_textbox(i).Text) - servo_data_present(i)
                servo_diff(i) = total_diff / 50
            Next
        Else
            For i = 0 To 7
                total_diff = JointCalc.angle2servo(i, Val(ar_textbox(i).Text)) - JointCalc.angle2servo(i, servo_data_present_deg(i))
                servo_diff(i) = total_diff / 50
            Next
        End If

        move_all_servo(servo_data_present, servo_diff)

        If radioRaw.Checked = True Then
            For i = 0 To 7
                servo_data_present(i) = Val(ar_textbox(i).Text)
                servo_diff(i) = 0
            Next
        Else
            For i = 0 To 7
                servo_data_present_deg(i) = Val(ar_textbox(i).Text)
                servo_data_present(i) = JointCalc.angle2servo(i, servo_data_present_deg(i))
                servo_diff(i) = 0
            Next
        End If

    End Sub

    '全部のサーボを動かすモード
    Private Sub move_all_servo(ByRef servo_data_present() As Integer, ByRef servo_diff() As Integer)
        Dim i, k, id, side_id, servo_data As Integer
        Dim buff(4) As Byte
        Dim a As Double
        Dim servo_data_str As String

        '角度指定で動かす場合は関節パラメータファイルの情報をベースに入力チェック
        If radioDeg.Checked = True Then
            For i = 0 To 7
                side_id = 0
                id = i
                a = Val(ar_textbox(i).Text)
                If a < servo_min_max(side_id, id, 0) Or a > servo_min_max(side_id, id, 1) Then
                    MsgBox("エラー：入力値が関節稼働範囲を超えています", MsgBoxStyle.Exclamation)
                    Exit Sub
                End If
            Next
        End If

        '０番～７番サーボに信号出力値を送信する
        If radioRaw.Checked = True Then
            'Rawモード
            If chkMoveSlow.Checked = True Then
                '補間有(50Pointで固定)
                For k = 0 To 49
                    'マイコンにＲＣサーボ制御信号　状態変更コマンドを送信
                    write_sio_command("B")
                    For i = 0 To 7
                        servo_data_present(i) = servo_data_present(i) + servo_diff(i)
                        servo_data_str = Format(servo_data_present(i))
                        write_sio_int(servo_data_str)
                    Next
                Next
            Else
                '補間なし
                'マイコンにＲＣサーボ制御信号　状態変更コマンドを送信
                write_sio_command("B")
                For i = 0 To 7
                    servo_data_str = ar_textbox(i).Text
                    write_sio_int(servo_data_str)
                Next
            End If
        Else
            If chkMoveSlow.Checked = True Then
                '補間有(50Pointで固定)
                For k = 0 To 49
                    'マイコンにＲＣサーボ制御信号　状態変更コマンドを送信
                    write_sio_command("B")
                    For i = 0 To 7
                        servo_data_present(i) = servo_data_present(i) + servo_diff(i)
                        servo_data_str = Format(servo_data_present(i))
                        write_sio_int(servo_data_str)
                    Next
                Next
            Else
                'マイコンにＲＣサーボ制御信号　状態変更コマンドを送信
                write_sio_command("B")
                '補間なし
                For i = 0 To 7
                    a = Val(ar_textbox(i).Text)
                    servo_data = JointCalc.angle2servo(i, a)

                    servo_data_str = Format(servo_data)
                    write_sio_int(servo_data_str)
                Next
            End If
        End If
    End Sub

    '脱力*******************************************
    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click

        Dim buff(8) As Byte
        Dim servo_data_str As String

        If passive_mode = False Then
            'ボタンの色を動作中色に変更
            Me.Button3.BackColor = Values.active_button_color

            passive_mode = True
            btnSnedData.Enabled = False

            write_sio_command("K")
            buff(0) = 0
            frmMain.SerialPort1.Write(buff, 0, 1)
        Else
            'ボタンの色を停止中色に変更
            Me.Button3.BackColor = Values.org_back_color

            passive_mode = False
            btnSnedData.Enabled = True

            If first_move = True Then
                '補間なし
                'マイコンにＲＣサーボ制御信号　状態変更コマンドを送信
                write_sio_command("B")
                For i = 0 To 7
                    servo_data_str = ar_textbox(i).Text
                    write_sio_int(servo_data_str)
                Next
                first_move = False
            End If

            write_sio_command("K")
            buff(0) = 1
            frmMain.SerialPort1.Write(buff, 0, 1)
        End If

    End Sub

    'ホームポジションをファイルから読み込む
    Private Sub joint_home_read()
        Dim work_str, work_str_arr() As String
        Dim i As Integer
        Dim in_fname As String = "edu_arm1_joint_home.dat"

        If IO.File.Exists(in_fname) Then
            FileOpen(2, in_fname, OpenMode.Input)

            Do While Not EOF(2)

                work_str = LineInput(2)
                work_str_arr = work_str.Split(",")

                'ＲＣサーボ出力値のデフォルト
                For i = 0 To 7
                    work_str = "joint_data_org_" + Format(i)
                    If work_str_arr(0) = work_str Then
                        ar_textbox(i).Text = work_str_arr(1)
                    End If
                Next
            Loop

            FileClose(2)

        Else
            MsgBox("edu_arm1_joint_home.datファイルが見つかりません。")
            Exit Sub
        End If

    End Sub

    'ReLoad ボタン
    Private Sub btnReload_Click(sender As System.Object, e As System.EventArgs) Handles btnReload.Click

        joint_home_read()

        'ＲＣサーボを（このフォームの）初期値に戻す
        For i = 0 To 7
            ar_textbox(i).Text = joint_data_org(i)
        Next

        radioDeg.Checked = False
        radioRaw.Checked = True

    End Sub

    Private Sub btnSave_Click(sender As System.Object, e As System.EventArgs) Handles btnSave.Click
        Dim work_str As String
        Dim i As Integer
        Dim out_fname As String = "edu_arm1_joint_home.dat"

        FileOpen(1, out_fname, OpenMode.Output)

        'ＲＣサーボ出力値のデフォルト
        PrintLine(1, "#ＲＣサーボ中立位置")
        For i = 0 To 7
            work_str = "joint_data_org_" + Format(i) + "," + ar_textbox(i).Text
            PrintLine(1, work_str)
        Next

        FileClose(1)

        MsgBox("edu_arm1_joint_home 出力完了")

    End Sub

    'パラメータファイル読み込み
    Private Sub btnPlmLoad_Click(sender As System.Object, e As System.EventArgs) Handles btnPlmLoad.Click
        Dim i, id As Integer

        JointPlm.fread_convtab("edu_arm1_convtab.pal")
        frmPlmEdit.cmbJointSelect.SelectedIndex = 0
        i = 0
        id = 0
        frmPlmEdit.txtLeftDeg.Text = servo_st_en(i, id, 0)
        frmPlmEdit.txtLeftRaw.Text = servo_st_en(i, id, 1)
        frmPlmEdit.txtMidDeg.Text = servo_st_en(i, id, 2)
        frmPlmEdit.txtMidRaw.Text = servo_st_en(i, id, 3)
        frmPlmEdit.txtRightDeg.Text = servo_st_en(i, id, 4)
        frmPlmEdit.txtRightRaw.Text = servo_st_en(i, id, 5)

    End Sub

    'パラメータファイル書き出し
    Private Sub btnPlmSave_Click(sender As System.Object, e As System.EventArgs) Handles btnPlmSave.Click
        JointPlm.fwrite_convtab("edu_arm1_convtab.pal")
    End Sub

    Private Sub radioDeg_CheckedChanged(sender As Object, e As System.EventArgs) Handles radioDeg.CheckedChanged
        Dim i
        If radioDeg.Checked = True Then
            '関節データの入力を　度単位の角度に切り替える
            'ＲＣサーボの値をセーブ
            For i = 0 To 7
                joint_data_raw(i) = ar_textbox(i).Text
                ar_textbox(i).Text = joint_data_deg(i)
            Next
        Else
            '関節データの入力を　サーボの生データに切り替える
            'ＲＣサーボの値をセーブ
            For i = 0 To 7
                joint_data_deg(i) = ar_textbox(i).Text
                ar_textbox(i).Text = joint_data_raw(i)
            Next
        End If
    End Sub


    '生成　ボタンの処理
    '関節パラメータファイルの中立位置（ゼロ度）を読みだして、rawデータテキストボックスにセットする
    Private Sub btnGenerateNewtraldata_Click(sender As System.Object, e As System.EventArgs) Handles btnGenerateNewtraldata.Click

        Dim i, j, servo_data As Integer

        j = 0
        For i = 0 To 7
            '０度のｒａｗデータを求める
            servo_data = JointCalc.angle2servo(i, 0.0)
            ar_textbox(i).Text = Format(servo_data)
        Next

    End Sub

    Private Sub btnTest_Click(sender As System.Object, e As System.EventArgs) Handles btnTest.Click
        Dim coo(3), joint_angle(3) As Double
        Dim servo_data(3) As Integer

        coo(0) = Val(txtCooX.Text)
        coo(1) = Val(txtCooY.Text)
        coo(2) = Val(txtCooZ.Text)

        JointCalc.coo2servo3ax(coo, servo_data, joint_angle)

        If radioRaw.Checked = True Then
            TextBox1.Text = Str(servo_data(0))
            TextBox2.Text = Str(servo_data(1))
            TextBox3.Text = Str(servo_data(2))
        Else
            TextBox1.Text = Format(joint_angle(0), "0.0")
            TextBox2.Text = Format(joint_angle(1), "0.0")
            TextBox3.Text = Format(joint_angle(2), "0.0")
        End If

    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        frmPgmMode.Visible = True
        Me.Visible = False
        frmPlmEdit.Visible = False
    End Sub
End Class